<?php
session_start();
header('Content-Type: text/html; charset=utf-8');
$instance_id = $_SESSION['client_id'];
//require "log.php";
//include "../settings.php";
 require_once("../settings.php");
require_once("ClassLibs/ClassReport.php");
require_once("ClassLibs/ClassTimeDate.php");
require_once("ClassLibs/ClassMessageAndLogs.php"); 
include "writedblog.php";

$dbset = json_decode($_SESSION['settingsApp'],true);
$db = new mysqli ($dbset['DB']['DB_HOST'],$dbset['DB']['DB_USER'],$dbset['DB']['DB_PASS'],$dbset['DB']['DB_NAME']);
//$db = new mysqli ($DB_HOST,$DB_USER,$DB_PASS,$DB_NAME);
$db->query("SET CHARSET SET utf8");
$db->query("SET NAMES 'utf8'");
if (mysqli_connect_errno()) {
	echo "Error connecting to DB";
	exit;
}

$DB1 = new mysqli ($EDB_HOST,$EDB_USER,$EDB_PASS,$EDB_NAME);
$DB1->query("SET CHARSET SET utf8");
$DB1->query("SET NAMES 'utf8'");

$ObjReportTOiR = new Report('tms_gpsdata_fixed');
$ObjTimeDateTOiR = new TimeDate();
$ObjLogsTOiR = new MessageAndLogs();

if ($_REQUEST['func'] == 'getResult') {	
	$FromTime = $_POST['date_from'];
	$ToTime = $_POST['date_to'];
	$strOfWorkersID = $_REQUEST['strOfWorkersID'];
	$strOfStatusID = $_REQUEST['strOfStatusID'];
	$Store = '';
	//echo $FromTime.' '.$ToTime.' '.$strOfWorkersID.' '.$strOfStatusID; 
	
			//$ColumnsOfTable=array();
			$ColumnsOfTable=array('Дата','Бригада','Точка','Плановое время','Фактическое время','Статус');
	
			//$Model='["result_1","result_2","result_3","result_4","result_5","result_6","result_7","result_8","result_9","result_10","result_11"]';
			$Model='["result_1","result_2","result_3","result_4","result_5", "result_6"]';
		
	
			
			$Query="SELECT DATE(r.`time_execut`), u.name, o.name, r.`work_duration`, IF(r.`fact_work_duration`, r.`fact_work_duration`, 0),
					IF (r.`status`, 'Выполнен', 'Не Выполнен') FROM `toir_request` r
						INNER JOIN `toir_users` u ON  u.`id`=r.`name_master`
						INNER JOIN `toir_outlets` o ON o.`id_outlet`=r.`outlet_id`
						WHERE r.`time_execut`>='$FromTime' AND r.`time_execut`<='$ToTime' AND r.`instance_id`=$instance_id
						AND u.`id` IN ($strOfWorkersID) AND r.status IN ($strOfStatusID) ORDER BY r.`time_execut` DESC , u.name ASC";
			
			//echo $Query;
			$Stmt = $db->prepare($Query);
			$Stmt->execute();
			$Stmt->bind_result($date, $worker, $TT, $work_duration, $fact_work_duration, $status);
			while ($Stmt->fetch())
			{				
				$Store.='{"result_1":"'.$date.'","result_2":"'.$worker.'","result_3":"'.$TT.'",
                            		"result_4":"'.$work_duration.'","result_5":"'.$fact_work_duration.'","result_6":"'.$status.'"},';
			}
	
			//print_r($Store); exit;
			
   
	                    				//$ObjReportRun->SetBodyByTitle($ColumnsOfTable,$FTime,$TTime);
//$ObjReportRun->SetBodyByTitleGroupingsummary($ColumnsOfTable,$FTime,$TTime,'Итого',array(0,5,8,10),array('sum','sum','sum'),array(90,105,140,135,135,95,95,95,95,95,95));
			$ObjReportTOiR->SetBodyByTitleWidth($ColumnsOfTable,$FromTime,$ToTime,array(80,90,90,80,250,110));
$ObjReportTOiR->SetModel($Model);
$ObjReportTOiR->SetStore($Store);
$ObjReportTOiR->GetCountColumns($Model);
$Stmt->close();
$db->close();
                    						 
//$ObjLogs->WriteLogAttendance("Окончание создания отчета по движению; client_id:".$ClientId,'AttendanceLog','../logs');
//$ObjLogs->WriteLogsToDB(6,"client_id:".$client_id,2,$Login);
echo  json_encode($ObjReportTOiR);
}

if ($_POST['func']=='export_xls')
{
	$Title= 'Отчет';
	$Data=$_POST['ColumnsArray'];
	$Fields= array('Дата','Бригада','Точка','Плановое время','Фактическое время','Статус');	
	$ObjReportTOiR->ExportExcel($Fields,$Title,$Data);
}

if ($_GET['func']=='save_export_xls')
{
	$ObjReportTOiR->SaveExcel();
}

if ($_POST['func']=='export_print')
{
	$Title= 'Отчет';
	$Data=$_POST['ColumnsArray'];
	$Fields= array('Дата','Бригада','Точка','Плановое время','Фактическое время','Статус');
	$ObjReportTOiR->ExportPrint($Fields,$Title,$Data);
}

if ($_GET['func']=='save_export_print')
{
	$ObjReportTOiR->SavePrint();
}

if ($_POST['func']=='export_csv')
{
	$Title= 'Отчет';
	$Data=$_POST['ColumnsArray'];
	$Fields= array('Дата','Бригада','Точка','Плановое время','Фактическое время','Статус');
	$ObjReportTOiR->ExportCSV($Fields,$Title,$Data);
}

if ($_GET['func']=='save_export_csv')
{
	$ObjReportTOiR->SaveCSV();
}
