var TOiR_users_Window = null;
//var TOiR_users_WindowAddEdit = null;
// var TOiR_UserStore ;

Ext.define('TOiR_RolesModel', {
    extend: 'Ext.data.Model',
    fields: ['id', 'type']
});

var TOiR_RolesStore = new Ext.data.Store({
		// autoDestroy: true,
        model: 'TOiR_RolesModel',
        proxy: 
        {
          type: 'ajax',
          url: 'app/TOiR_users.php?func=roles',
          reader: 
          {
            type: 'json',
            root: 'rows'
          }
        }
});

Ext.define('TOiR_UserModel', {
    extend: 'Ext.data.Model',
    fields: ['id','name', 'password','id_role','tel','email','post','department','imei', 'external_id']
});

TOiR_UserStore = new Ext.data.Store(
  {
        autoLoad: true,
    // autoDestroy: true,
        model: 'TOiR_UserModel',
        proxy: 
        {
          type: 'ajax',
          url: 'app/TOiR_users.php?func=show',
          reader: 
          {
            type: 'json',
            root: 'rows'
          }
        }
});

function show_TOiR_users_Window(Xcoord,Ycoord,Wwidth,Wheight){
	
        Xcoord = Xcoord ? Xcoord :40;
        Ycoord = Ycoord ? Ycoord :60;  
        Wwidth = Wwidth ? Wwidth :815;  
        Wheight = Wheight ? Wheight :400;



// TOiR_RolesStore.load();

var usersGrid = Ext.create('Ext.grid.Panel',{
    selType: 'rowmodel',
    columnLines: true,
    id: 'TOiR_UserGridId',
    store: TOiR_UserStore,
    loadMask: true,
    border: false,
    // stripeRows: true,
    // columnLines: true,
    autoScroll: true,
  dockedItems: [{
            xtype: 'toolbar',
            items: [{
                //text: 'Добавить',
                text: all_toir.add,
                iconCls: 'add',
                handler: function(){
          show_TOiR_users_WindowAddEdit();
        }
        },'-',{
                //text: 'Удалить',
                text: all_toir.del,
                iconCls: 'delete',
                handler: function(){
              var select = Ext.getCmp('TOiR_UserGridId').getView().getSelectionModel().getSelection()[0];
                            if (select) {
                                Ext.MessageBox.confirm(mess_toir.deleting, mess_toir.are_you_sure_you_want_to_delete_the_record, function(btn) {
                                    if (btn == 'yes') {
                                        //alert(select.get('id'));
                                        Ext.Ajax.request({
                                            url: 'app/TOiR_users.php',
                                            method: 'POST',
                                            params: {"func": "del", "name": select.get('id')},
                                            success: function(response) {
                                                Ext.getCmp('TOiR_UserGridId').store.load();
                        Ext.getCmp('TOiR_UserGridId').getView().refresh();
                                            },
                                            failure: function(response) {
                                                Ext.MessageBox.alert(all_toir.error, response.responseText);
                                            }
                                        });
                                    }
                                });
                            } else {
                                Ext.MessageBox.alert(all_toir.error, all_toir.select_row);
                            }
        }
        },'-',{
                //text: 'Редактировать',
                text: all_toir.edit,
                iconCls: 'edit',
                handler: function(){
          var select = Ext.getCmp('TOiR_UserGridId').getView().getSelectionModel().getSelection()[0];
                            if (select) {
                show_TOiR_users_WindowAddEdit(select.get('id'));
              } else {
                                Ext.MessageBox.alert(all.error, all.select_row);
                            }
        }
        }
      ]
  }],
  listeners: {
    itemdblclick: function() {
      var select = Ext.getCmp('TOiR_UserGridId').getView().getSelectionModel().getSelection()[0];
                show_TOiR_users_WindowAddEdit(select.get('id'));                           
    }
  },
    columns:[
     {
            xtype: 'rownumberer',
            width: 30,
            sortable: false,
            hideable: true
            
        },
      {
        text: user_toir.username,
        //text: 'Имя пользователя', 
        dataIndex: 'name',
        sortable: true,
        flex:1,
      },
      {
        //text: 'Пароль',
        text:  user_toir.password, 
        dataIndex: 'password',
        hideable: false,
        sortable: true,        
        flex:1
      },
      {
        text: 'Роль', 
        dataIndex: 'id_role',
        sortable: true,
        hidden: true,
        flex:1
      },
      {
        //text: 'Телефон',
        text: user_toir.phone, 
        dataIndex: 'tel',
        sortable: true,
        flex:1
      },
      {
        text: 'E-mail', 
        dataIndex: 'email',
        sortable: true,
        flex:1
      },
      {
        //text: 'Должность',
        text: user_toir.job_title, 
        dataIndex: 'post',
        sortable: true,
        flex:1
      },
      {
        //text: 'Департамент',
        text: user_toir.department,        
        dataIndex: 'department',
        sortable: true,
        flex:1
      },
      {
        text: 'IMEI', 
        dataIndex: 'imei',
        sortable: true,
        //flex:1
      },
      {
    	  //text: 'Внешний ID',
    	  text: user_toir.external_id,
          dataIndex: 'external_id',
          sortable: true,
          flex:1
      }
    ]
});
	
    if (!TOiR_users_Window){
        Ext.getBody().mask(all.loading);
        TOiR_users_Window = new Ext.Window({
            layout : 'fit',
            //title : 'Пользователи',
            title : TOiR.users,
            closeAction : 'destroy',
            width : parseInt(Wwidth),
            height : parseInt(Wheight),
            //minimizable: true,
			// constrainHeader: true,
            maximizable:true,
            //x : parseInt(Xcoord),
            //y : parseInt(Ycoord),
			listeners : {
            	destroy : function(){
					TOiR_users_Window = null;	
            	}
            },
            items : [usersGrid]
        });
        
    }
    
    TOiR_users_Window.show();
    Ext.getBody().unmask(all.loading);
	
}


function show_TOiR_users_WindowAddEdit(id)
{
	
	
	
	if (!id){
        //var t = calendar.adding_tasks;
		    //var t = "Добавить";
		    var t = all_toir.add;
        var func = 'addedit';
        //var succMsg = 'Пользователь успешно добавлен';
        var succMsg = mess_toir.user_successfully_added;
    }else{
        //var t = calendar.editing_tasks;
		//var t = "Редактировать";
		var t = all_toir.edit;
        var func = 'addedit';
        //var succMsg = 'Данные пользователя успешно изменены';
        var succMsg = mess_toir.user_data_is_successfully_changed;
    }

    TOiR_RolesStore.load();
	
	if(!TOiR_users_WindowAddEdit){
         var TOiR_users_WindowAddEdit = new Ext.Window({
                        width:400,
                        height:350,
                        title: t,
                        closeAction : 'destroy',
                        layout:'fit',
                        resizable: true,
						constrainHeader: true,
                        modal:true,
						listeners : {
						destroy : function(){
							TOiR_users_WindowAddEdit = null;	
						}
						},
                        items:[
						{
						xtype: 'form',
						autoScroll: true,
						bodyPadding: '5 5 5 5',
						id: "TOiR_UserFormId",
						border: false,
						frame: true,
						autoHeight: true,
						//fieldwidth:'width:150px',
						//layout: 'anchor',
						layout: {
							type: 'vbox',
							align: 'stretch'
						},
						// defaults: {
						// 	//fileUpload: true,
						// 	labelAlign: 'left',
						// 	labelWidth: 90,
						// 	//fieldWidth: '90%',
						// 	msgTarget: 'side'
						// },
						items:[
						{
                          xtype:'textfield',
                          //fieldLabel: 'Имя пользователя',
                          fieldLabel: user_toir.username,
						              //anchor: '100%',
                          allowBlank: false,
						              name : 'name'
                        },
                        {
                          xtype:'textfield',
                          //fieldLabel: 'Пароль',
                          fieldLabel: user_toir.password,
						              //anchor: '100%',
						              allowBlank: false,
                          name : 'password'
                        },
                        {
                          xtype:'combo',
                          fieldLabel: 'Роль',
            						  allowBlank: true,
            						  store: TOiR_RolesStore,
            						  queryMode: 'local',
            						  //anchor: '100%',
            						  displayField: 'type',
            						  valueField: 'id',
            						  typeAhead: false,
            						  triggerAction: 'all',
            						  lazyRender: true,
            						  editable: false,
            						  hidden: true,
                          name : 'id_role'
                        },
                        {
                          xtype:'textfield',
                          //fieldLabel: 'Телефон',
                          fieldLabel: user_toir.phone,
                          name : 'tel'
                        },
                        {
                          xtype:'textfield',
                          fieldLabel: 'E-mail',
                          name : 'email'
                        },
                        {
                          xtype:'textfield',
                          //fieldLabel: 'Должность',
                          fieldLabel: user_toir.job_title,
                          name : 'post'
                        },
                        {
                          xtype:'textfield',
                          //fieldLabel: 'Департамент',
                          fieldLabel: user_toir.department,
                          name : 'department'
                        },
                        {
                          xtype:'textfield',
                          fieldLabel: 'IMEI',
                          name : 'imei'
                        },
                        {
                        	xtype:'textfield',
                            //fieldLabel: 'Внешний ID',
                            fieldLabel: user_toir.external_id,
                            name : 'external_id'
                        }
						],buttons:[
							{ 
							//text:'Сохранить',
							text: all.save,
							//id:'buttonUploads',
							iconCls:'save',
							handler: function() {			
								var form = this.up('form').getForm();
								if(form.isValid()){
								form.submit({
									//waitMsg:'Идет отправка...',
									waitMsg: all_toir.loading,
                                    url: 'app/TOiR_users.php',
									//waitMsg: 'Збереження...',
									wait: true,
									scope: this,
									method: 'post',
									//timeout : 60000,
									params: {func:func,id:id},
                                    success: function(fp, o){
                                        console.log(o);
										if(o.result.success == true || o.result.success == 'true'){
											// Ext.Msg.alert('Выполнено',succMsg); 
											TOiR_users_WindowAddEdit.destroy();
                      // Ext.getCmp('TOiR_UserGridId').store.destroy();
											Ext.getCmp('TOiR_UserGridId').store.load();
                      // TOiR_users_Window.destroy();
                      // TOiR_users_Window.show();
											Ext.getCmp('TOiR_UserGridId').getView().refresh();
										}else{
											Ext.MessageBox.alert(all_toir.error, o.result.message);
										}
                                    },
									failure: function(fp, o){
										 console.log(o);
										Ext.MessageBox.alert(all_toir.error, o.result.message);
									}
								});
							}
							}
							},
							{
                            //text: 'Отмена',
                            text: all_toir.cancel,
							iconCls:'cancel',
                            handler: function(){
                                TOiR_users_WindowAddEdit.destroy();
                            }
							}
						]
						}
						]
		});
	}
	TOiR_users_WindowAddEdit.show();
	
	
	var form = Ext.getCmp("TOiR_UserFormId").getForm().getFields();
    if (id) {
        Ext.Ajax.request({
            url: 'app/TOiR_users.php',
            method: 'POST',
            params: {"func":"editshow","id":id},
            success: function(response) {
                var JSON = response.responseText;
                 //console.log(JSON);
                if (JSON) {
                    var decoded = Ext.decode(JSON);
					          var i = 0;
          					form.each(function(item) {
                     
            					if (item.xtype == 'combo') {                                    
            						          item.setValue(parseInt(decoded[i]));                                
                      } else {
            						          item.setValue(decoded[i]);
            					}
            					i++;
                    });

                }
            },
            failure: function(response) {
                Ext.MessageBox.alert(all_toir.error, response.responseText);
            }
        });
    }
	
}